--------------------------------------------------------------------------------
--  
-- Project Name:  ASIC design contest
-- Visit http://fpgasoc.sbu.ac.ir
-- Description:   
-- 
-- VHDL sample code for DDS module.

-- A sample code to be tested with the testbench


-- 
-- Revision:2
--
--------------------------------------------------------------------------------

LIBRARY ieee;
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use ieee.std_logic_unsigned.all;
use ieee.numeric_std.all;
use IEEE.math_real.all;


-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;



entity DDS is
    Port ( RXD : in  STD_LOGIC;
           Start : in  STD_LOGIC;
           CLK : in  STD_LOGIC;
           SOUT : out  STD_LOGIC_VECTOR (9 downto 0);
           COUT : out  STD_LOGIC_VECTOR (9 downto 0));
end DDS;

architecture Behavioral of DDS is

	-- user constant
	--
	constant CLK_period 	: time 		:= 10 ns;			
	constant	CLK_ferq		: integer	:= 100_000_000;		
	constant m				: integer	:=30;
	constant d				: integer	:=10;



	signal	isinc	:	real	:=	0.0;
	signal	fcw		:	STD_LOGIC_VECTOR (39 downto 0);

	

begin


	

	proc1: process(CLK,Start)
		variable cnt : real:=0.0;
			begin
				if Start='1'	then

					--isinc is used to compensate the lower amplitude caused by the sinc function at frequencies close to FCLK/2.
					--isinc=pi*(F0/FCLK)/sin(pi*(F0/FCLK)), where F0/FCLK=FCW/2^m

					isinc<=(2.0*((real(to_integer(unsigned(fcw))))/2.0**m))/sin(3.141592*((real(to_integer(unsigned(fcw))))/2.0**m));

					if rising_edge(CLK)	then
						SOUT<=std_logic_vector ( to_signed ( integer((round((2.0**(d))*((0.5*SIN((2.0*3.141592*cnt)/(2.0**m))*isinc+0.5))))),d));
						COUT<=std_logic_vector ( to_signed ( integer((round((2.0**(d))*((0.5*cos((2.0*3.141592*cnt)/(2.0**m))*isinc+0.5))))),d));
						cnt:=cnt+real(to_integer(unsigned(fcw(m-1 downto 0))));

						if (cnt>=2.0**m)	then
							cnt:=0.0;
						end if;
					end if;
				end if;

	end process;

	fcwgraber: process
		begin
		wait for 104 us;
		if Start='0'	then
		for i in 0 to	4	loop
			wait for 8.68 us ;
			for j in 0 to 7	loop
				
				fcw((i*8)+j)<=RXD;
				wait for 8.68 us ;
			end loop;
			wait for 2*8.68 us;
		end loop;
		end if;
		end process;
		

end Behavioral;

